#!/usr/bin/python
# -*- coding: utf-8 -*-

import kinterbasdb
import urllib
from lxml.html import parse, HTMLParser
from threading import Thread, Lock
from datetime import datetime
import time
from configobj import ConfigObj
import os

class fb:
    "Робота з FB"
    def __init__(self, section):
        self.con = kinterbasdb.connect(
            host = fb_config[section]['host'], database = fb_config[section]['name'],
            user = fb_config[section]['user'], password = fb_config[section]['pass'], charset = fb_config[section]['charset']
        )
 
    def selectSQL(self, query, params=([])):
        "Select data from db"
        cur = self.con.cursor()
        cur.set_type_trans_in ({'BLOB': {'mode': 'stream'}})
        cur.set_type_trans_out({'BLOB': {'mode': 'stream'}})
        try:
            cur.execute(query, params)
            result = cur.fetchall()
            cur.close()
            self.con.commit()
        except kinterbasdb.ProgrammingError (errNumb, errText):
            cur.close()
            self.con.rollback()
            result = (errNumb, errText, query)
        except:
            cur.close()
            self.con.rollback()
            result = (-1, 'Unknown error', query)
        finally:
            return result

    def execSQL(self, query, params=([])):
        cur = self.con.cursor()
        cur.set_type_trans_in ({'BLOB': {'mode': 'stream'}})
        cur.set_type_trans_out({'BLOB': {'mode': 'stream'}})
        try:
            cur.execute(query, params)
        except kinterbasdb.ProgrammingError (errNumb, errText):
            cur.close()
            self.con.rollback()
            result = (errNumb, errText, query)
        except:
            cur.close()
            self.con.rollback()
            result = (-1, 'Unknown error', query)
        else:
            cur.close()
            self.con.commit()
            result = (0, 'Success', query)
        finally:
            return result
# кінець класу для роботи з базою

def processArmina(pageurl):
    def doGroup(href, group_id, group_parent, group_name):
        tov_group = []
        fbclient = fb('autos')
        if fbclient.selectSQL('select 1 from groups where group_parent = ?', (group_id,)) == []:   # не збирати товари з груп в яких є підгрупи
            page = parse('http://www.armina.ru/' + href + '&cou=v').getroot()
            article, name, small_pic, large_pic = [], [], [], []
            for one in page.xpath('//a[@rel="lytebox"]'):
                article.append(one.xpath('@title')[0].split()[1])   # на armina це має значення external_id
                name.append(one.xpath('img/@alt')[0])
                small_pic.append('http://www.armina.ru/' + one.xpath('img/@src')[0])
                large_pic.append('http://www.armina.ru/' + one.xpath('@href')[0])
            tov_group = zip(article, name, small_pic, large_pic)
            time.sleep(2)
        autoToBase(group_id, group_parent, group_name, tov_group, fbclient)

    report(datetime.now().strftime("%d.%m.%Y %X") + ' початок парсингу armina.ru\n')
    page = parse(pageurl).getroot()
    for group in page.xpath('//td[img]/a'):
        href = group.xpath('@href')[0]
        group_id = int(href.split('idcateg=')[1].split('&')[0])
        group_parent = int(href.split('catid=')[1].split('&')[0])
        group_name = group.xpath('text()')[0].strip()
        doGroup(href, group_id, group_parent, group_name)
    for group in page.xpath('//table[@valign="top"]/tr/td/a[u]'):
        href = group.xpath('@href')[0]
        group_id = int(href.split('catid=')[1].split('&')[0])
        group_parent = int(href.split('grid=')[1])
        group_name = group.xpath('u/text()')[0]
        doGroup(href, group_id, group_parent, group_name)
    for group in page.xpath('//table[@valign="top"]/tr/td/a[b]'):
        href = group.xpath('@href')[0]
        group_id = int(href.split('grid=')[1])
        group_parent = None
        group_name = group.xpath('b/text()')[0]
        doGroup(href, group_id, group_parent, group_name)
    report(datetime.now().strftime("%d.%m.%Y %X") + ' кінець парсингу armina.ru\n')

def autoToBase(group_id, group_parent, group_name, tov_group, fbclient):
        if fbclient.selectSQL('select 1 from groups where id = ?', (group_id,)) == []:
            qu = fbclient.execSQL('insert into groups (id, group_parent, group_name) values(?, ?, ?)', (group_id, group_parent, group_name))
        for article, name, small_pic, large_pic in tov_group:
            if fbclient.selectSQL('select 1 from goods where article = ?', (article,)) == []:
                qu = fbclient.execSQL('insert into goods (name, article, group_id, small_pic, large_pic) values(?, ?, ?, ?, ?)',
                                      (name, article, group_id, urllib.urlopen(small_pic), urllib.urlopen(large_pic) ))
                print name
       
def report(line):
    lock.acquire()
    rfile.write(line)
    lock.release()
          
if __name__ == '__main__':
    fb_config = ConfigObj(os.path.join(os.path.dirname(__file__), 'firebird.ini'))
    kinterbasdb.init(concurrency_level=2)
    lock = Lock()
    p1 = Thread(target=processArmina, args=['http://www.armina.ru/osnov.php?ss=1',])

    pathTolog = fb_config['log']['name']
    try:
        rfile = open(pathTolog, 'a', 0)
        if os.statvfs(pathTolog).f_bavail < 2560:
             report('На диску мало вільного місця\n')
    except IOError:
        print 'Помилка вводу-виводу: ', pathTolog
        exit()

    p1.start()
    p1.join()

    rfile.close()
